/** Master */

#include <Wire.h>
// note: an int is two bytes: http://www.ladyada.net/learn/arduino/lesson4.html

void setup()
{
  Wire.begin(); // join i2c bus (address optional for master)
}

byte x = 0;
byte current_move = 0;
byte column = 1;
byte last_opponent_move = -1;

void loop()
{
  // TODO Do our move
  
  Wire.beginTransmission(2); // transmit to device #4
  Wire.send("M");        // sends one bytes
  Wire.send(current_move);
  Wire.send(column);
  Wire.endTransmission();    // stop transmitting
  
  delay(500);
  // Send whether we are winning
  sendBoardStatusWire();

  // Check the opponent's move:
  while(!receiveWireMessage())
  {  
    Wire.requestFrom(2, 5);    // request 6 bytes from slave device #2
    delay(500);
  }
  
  // Do opponent move on our gameboard
  sendBoardStatusWire();
}

void sendBoardStatusWire()
{
  Wire.beginTransmission(2); // transmit to device #4
  Wire.send("S");        // sends one bytes
  Wire.send(current_move);
  Wire.send(column);
  Wire.endTransmission();    // stop transmitting
}

boolean receiveWireMessage()
{
  // the only message we will accept is {<byte>, <int>, <int>}, with <byte> == "M"
  char control = "X";
  byte opponent_move = -1;
  byte opponent_column = -1;

  if(Wire.available())
    control = Wire.receive();
  else
    return false;
  if(Wire.available())
    opponent_move = Wire.receive();
  else
    return false;
  if(Wire.available())
    opponent_column = Wire.receive();
  else
    return false;

  if(control != "M")
    return false;
  if(opponent_move != (current_move + 1))
    return false;

  // TODO check if column is a valid move
  
  last_opponent_move = opponent_move;
  current_move++;

  return true;
}
