#include <FourInARow.h>
#include <FourInARowBot.h>
//#include <iostream>

using namespace std;

int nColumns = 7; // <- if changed, change allMoves
int nRows = 6; // <- if changed, change allMoves
FourInARow m(nColumns, nRows);
int column = 0;
int count = 0;
int player = 0;
FourInARowBot a(&m, 1);
int allMoves[42]; // <- update this if nColumns and nRows are updated!! (nColumns * nRows)

void setup()
{
  Serial.begin(9600);               // 115200 is the default Arduino Bluetooth speed
}

// http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1269302644
boolean lineAvailable(int max_line,char *line)
{
	int c;
	static int line_idx = 0;
	boolean eol = false;
	if (max_line <= 0)    // handle bad values for max_line
	{
	  eol = true;
	  if (max_line == 0)
	    line[0] = '\0';
	}
	else		    // valid max_line
	{
	  if (Serial.available() > 0)
	  {
	    c = Serial.read();
	    if (c != -1)  // got a char -- should always be true
	    {
		if (c == '\r')
		  eol = true;
		else
		  line[line_idx++] = c;
		if (line_idx >= max_line)
		  eol = true;
		line[line_idx] = '\0';     // always terminate line, even if unfinished
		if (eol)
		  line_idx = 0;	     // reset for next line
		}
	    }
	  }
	  return eol;
} 

void loop()
{
  char line[1 + 1]; // must be at least 1 char > MAXLINE
  
    player = count % 2 + 1;
  count++;

  // If the game is over, we stop playing:
  if(m.getState() != 0)
  {
	if(m.getState() == -1)
		Serial.println("It was a draw!");
	else
        {
		Serial.print("Player ");
                Serial.print(m.getState());
                Serial.println(" has won");
        }
        
        m.print();
        
        Serial.println("All moves:");
        for(int i = 0; i < count; i++)
        {
          Serial.print(allMoves[i]);
          Serial.print(", ");
        }
        // stopping program:
        while(true)
          {;}
  }
  
  // Decide which player does a move, player 1 or two:
  if(player == 2)
  {
    Serial.println();
    Serial.println();
    Serial.println();
    m.print();
    // human player
    Serial.print("Please say in which column player ");
    Serial.print(player);
    Serial.println(" should add a block...");
    
    while (!lineAvailable(1,line))  // until a line has been read
      {;}  // do nothing

    column = atoi(line);
    Serial.println(column);
  }
  else
  {
    // computer player
    column = a.calculateNextMove();
  }
  m.addBlock(column, player);
  
  // add to allmoves, count starts at 1
  allMoves[count - 1] = column;
}
